VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "howto_draw_ellipse_transformation"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4230
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4230
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub CirclePoint(ByVal theta As Single, ByVal circle_radius As Single, ByRef x As Single, ByRef y As Single)
    x = circle_radius * Cos(theta)
    y = circle_radius * Sin(theta)
End Sub
Private Sub RotatePoint(ByVal theta As Single, ByRef x As Single, ByRef y As Single)
Dim new_x As Single
Dim new_y As Single

    new_x = x * Cos(theta) + y * Sin(theta)
    new_y = x * Sin(theta) - y * Cos(theta)
    x = new_x
    y = new_y
End Sub
Private Sub ScalePoint(ByVal scale_x As Single, ByVal scale_y As Single, ByRef x As Single, ByRef y As Single)
    x = x * scale_x
    y = y * scale_y
End Sub
Private Sub TranslatePoint(ByVal tx As Single, ByVal ty As Single, ByRef x As Single, ByRef y As Single)
    x = x + tx
    y = y + ty
End Sub

Private Sub Form_Paint()
Const PI As Single = 3.14159265
Const DTHETA As Single = PI / 20
Const RADIUS As Single = 1440

Dim x0 As Single
Dim y0 As Single
Dim x As Single
Dim y As Single
Dim theta As Single

    ' Get the first point.
    CirclePoint 0, RADIUS, x, y
    ScalePoint 1, 0.5, x, y
    RotatePoint PI / 6, x, y
    TranslatePoint 1440, 1440, x, y
    CurrentX = x
    CurrentY = y
    x0 = x
    y0 = y

    ' Draw other points.
    For theta = DTHETA To 2 * PI Step DTHETA
        CirclePoint theta, RADIUS, x, y
        ScalePoint 1, 0.5, x, y
        RotatePoint PI / 6, x, y
        TranslatePoint 1440, 1440, x, y
        Line -(x, y)
    Next theta

    ' Close the circle.
    Line -(x0, y0)
End Sub
